package test.rewolucja.resources.manager.interfaces;

import java.util.List;
import java.util.Properties;

import test.rewolucja.resources.ResourceCharacteristics;
import test.rewolucja.resources.ResourceStatus;
import test.rewolucja.resources.ResourceType;
import test.rewolucja.resources.exception.ResourceException;
import test.rewolucja.resources.logical.base.LogicalResource;
import test.rewolucja.resources.physical.base.ComputingResource;

public interface ResourceManagerInterface {

	public boolean areResourcesAchievable(ResourceType type);
	
	public List<? extends ComputingResource> getResourcesOfType(ResourceType type) throws ResourceException;

	public ComputingResource getResourceByName(String resourceName) throws ResourceException;

	public List<? extends ComputingResource> getResourcesOfTypeWithStatus(ResourceType type, ResourceStatus status) throws ResourceException;

	public ResourceCharacteristics getResourceCharacteristic();
	
	public List<? extends ComputingResource> filterResources(Properties properties);
	
	public List<LogicalResource> getResourceProviders();

	public String getResourceProvider(String providerName);
}
